"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveBuilder = void 0;
const tslib_1 = require("tslib");
const build_kit_1 = require("@genesislcap/build-kit");
const builders = {
    ts: () => Promise.resolve().then(() => tslib_1.__importStar(require('@genesislcap/ts-builder'))).then((r) => r.default),
    rollup: () => Promise.resolve().then(() => tslib_1.__importStar(require('@genesislcap/rollup-builder'))).then((r) => r.default),
    webpack: () => Promise.resolve().then(() => tslib_1.__importStar(require('@genesislcap/webpack-builder'))).then((r) => r.default),
    vite: () => Promise.resolve().then(() => tslib_1.__importStar(require('@genesislcap/vite-builder'))).then((r) => r.default),
    'uvu-playwright': () => Promise.resolve().then(() => tslib_1.__importStar(require('@genesislcap/uvu-playwright-builder'))).then((r) => r.default),
    'eslint-stylelint': () => Promise.resolve().then(() => tslib_1.__importStar(require('@genesislcap/eslint-stylelint-builder'))).then((r) => r.default),
};
const resolveBuilder = (ctx) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    const { command, options: { builder }, } = ctx.cli;
    const id = (builder || // CLI param takes precedence
        ctx.config.builder[command] || // explicit command config
        ctx.config.builder.default || // default command config
        '').toLowerCase();
    const resolved = (builders[id] && (yield builders[id]())) || (0, build_kit_1.tryRequire)(id);
    if (!resolved) {
        throw new Error(`Couldn't resolve builder ${id} for command ${command}`);
    }
    return resolved;
});
exports.resolveBuilder = resolveBuilder;
